
CREATE TABLE ZMiscData (
  ObjId integer DEFAULT '0' NOT NULL,
  OClass varchar(15) DEFAULT '' NOT NULL,
  MId varchar(30) DEFAULT '' NOT NULL,
  Value_int integer,
  Value_string varchar(100),
  PRIMARY KEY (ObjId,OClass,MId)
);

CREATE TABLE ZRoles (
  Id integer NOT NULL,
  Rolename varchar(20) DEFAULT '' NOT NULL,
  Realm varchar(10) DEFAULT '' NOT NULL,
  PRIMARY KEY (Id),
  UNIQUE (Realm,Rolename)
);
CREATE GENERATOR ZRoles_seq;

CREATE TABLE ZSessions (
  Id integer NOT NULL,
  Id_User integer DEFAULT '0' NOT NULL,
  PRIMARY KEY (Id)
);
CREATE GENERATOR ZSessions_seq;

CREATE TABLE ZTokens (
  Id integer DEFAULT '0' NOT NULL,
  Class varchar(15) DEFAULT '' NOT NULL,
  TokenValue varchar(50),
  Created numeric(16,4) DEFAULT '0.0000' NOT NULL,
  Accessed numeric(16,4) DEFAULT '0.0000' NOT NULL,
  Timeout integer DEFAULT '0' NOT NULL,
  Life integer DEFAULT '0' NOT NULL,
  Realm varchar(10) DEFAULT '' NOT NULL,
  PRIMARY KEY (Id,Class)
);

CREATE TABLE ZUserRoles (
  Id_User integer DEFAULT '0' NOT NULL,
  Id_Role integer DEFAULT '0' NOT NULL,
  PRIMARY KEY (Id_User,Id_Role)
);
CREATE INDEX Id_User_ZUserRoles_index on ZUserRoles(Id_User);
CREATE INDEX Id_Role_ZUserRoles_index on ZUserRoles(Id_Role);


CREATE TABLE ZUsers (
  Id integer NOT NULL,
  Username varchar(60) DEFAULT '' NOT NULL,
  Realname varchar(50),
  EncPassword varchar(32),
  PasswordType integer DEFAULT '0' NOT NULL,
  Domains varchar (160) DEFAULT '' NOT NULL,
  Realm varchar(10) DEFAULT '' NOT NULL,
  EMail varchar(60),
  PRIMARY KEY (Id),
  UNIQUE (Realm,Username)
);
CREATE GENERATOR ZUsers_seq;

CREATE TABLE ZLog (
  Id integer NOT NULL,
  Realm varchar(10) DEFAULT '' NOT NULL,
  Id_Session integer,
  EventName varchar(10) DEFAULT '' NOT NULL,
  EValue varchar(200),
  EValue2 varchar(200),
  OType varchar(30),
  OSize integer,
  RAddr varchar (15),
  EventTime timestamp default current_timestamp,
  PRIMARY KEY (Id)
);
CREATE GENERATOR ZLog_seq;

