
CREATE TABLE ZMiscData (
  ObjId number(*,0) DEFAULT '0' NOT NULL,
  OClass varchar2(15) DEFAULT '' NOT NULL,
  MId varchar2(30) DEFAULT '' NOT NULL,
  Value_int number(*,0),
  Value_string varchar2(100),
  PRIMARY KEY (ObjId,OClass,MId)
);

CREATE TABLE ZRoles (
  Id number(*,0),
  Rolename varchar2(20) DEFAULT '' NOT NULL,
  Realm varchar2(10) DEFAULT '' NOT NULL,
  PRIMARY KEY (Id),
  UNIQUE (Realm,Rolename)
);
CREATE SEQUENCE ZRoles_seq;

CREATE TABLE ZSessions (
  Id number(*,0),
  Id_User number(*,0) DEFAULT '0' NOT NULL,
  PRIMARY KEY (Id)
);
CREATE SEQUENCE ZSessions_seq;

CREATE TABLE ZTokens (
  Id number(*,0) DEFAULT '0' NOT NULL,
  Class varchar2(15) DEFAULT '' NOT NULL,
  TokenValue varchar2(50),
  Created numeric(16,4) DEFAULT '0.0000' NOT NULL,
  Accessed numeric(16,4) DEFAULT '0.0000' NOT NULL,
  Timeout number(*,0) DEFAULT '0' NOT NULL,
  Life number(*,0) DEFAULT '0' NOT NULL,
  Realm varchar2(10) DEFAULT '' NOT NULL,
  PRIMARY KEY (Id,Class)
);

CREATE TABLE ZUserRoles (
  Id_User number(*,0) DEFAULT '0' NOT NULL,
  Id_Role number(*,0) DEFAULT '0' NOT NULL,
  PRIMARY KEY (Id_User,Id_Role)
);
CREATE INDEX Id_User_ZUserRoles_index on ZUserRoles(Id_User);
CREATE INDEX Id_Role_ZUserRoles_index on ZUserRoles(Id_Role);


CREATE TABLE ZUsers (
  Id number(*,0),
  Username varchar2(60) DEFAULT '' NOT NULL,
  Realname varchar2(50),
  EncPassword varchar2(32),
  PasswordType number(*,0) DEFAULT '0' NOT NULL,
  Domains varchar2 (160) DEFAULT '',
  Realm varchar2(10) DEFAULT '' NOT NULL,
  EMail varchar2(60),
  PRIMARY KEY (Id),
  UNIQUE (Realm,Username)
);
CREATE SEQUENCE ZUsers_seq;

CREATE TABLE ZLog (
  Id number(*,0),
  Realm varchar2(10) DEFAULT '' NOT NULL,
  Id_Session number(*,0),
  EventName varchar2(10) DEFAULT '' NOT NULL,
  EValue varchar2(200),
  EValue2 varchar2(200),
  OType varchar2(30),
  OSize number(*,0),
  RAddr varchar2 (15),
  EventTime timestamp default current_timestamp,
  PRIMARY KEY (Id)
);
CREATE SEQUENCE ZLog_seq;

